'use strict';

var axios = require('axios');
var rax = require('@iris-platform/retryable-axios');
var isClientToken = require('../utils/is-client-token');

var _require = require('../utils/constants'),
    ApiVersion = _require.ApiVersion;

var updateObject = async function updateObject(url, token, className, objectId, data, userId) {
  var isClient = isClientToken(token);

  var interceptorId = rax.attach();
  var ax = await axios({
    method: 'put',
    url: isClient ? url + '/' + ApiVersion + '/classes/' + className + '/objects/' + objectId : url + '/' + ApiVersion + '/classes/' + className + '/objects/' + objectId + '/userid/' + userId,
    timeout: 10000,
    headers: {
      "Content-Type": "application/json",
      "Authorization": 'Bearer ' + token
    },
    data: data,
    raxConfig: {}
  }).then(function (response) {
    return response.data;
  }).catch(function (error) {
    if (error.response) {
      throw { error: error.response.data };
    } else if (error.request) {
      //console.log(error.request);
      throw {
        error: {
          message: 'The request was made but no response was received'
        }
      };
    } else {
      //console.log(error.message);
      throw {
        error: {
          message: 'Something happened in setting up the request that triggered an Error'
        }
      };
    }
  });

  return ax;
};

module.exports = updateObject;