'use strict';

var requiredParam = require('./utils/required-param');
var MissingUserIdError = require('./errors/missing-user-id');

module.exports = function idsServerUser() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$auth = _ref.auth,
      auth = _ref$auth === undefined ? requiredParam('auth') : _ref$auth;

  var _impersonatedUserId = void 0;

  return Object.freeze({
    impersonate: impersonate,
    get userId() {
      return _impersonatedUserId;
    }
  });

  async function impersonate(type) {
    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        customId = _ref2.customId,
        mediaToken = _ref2.mediaToken,
        email = _ref2.email,
        password = _ref2.password;

    switch (type) {
      case 'custom':
        _impersonatedUserId = customId;
        return Promise.resolve(_impersonatedUserId);

      case 'email':
        data = await auth.emailLogin(email, password);
        if (!data.id) {
          throw new MissingUserIdError();
        }
        _impersonatedUserId = data.id;
        return Promise.resolve(_impersonatedUserId);
    }
  }
};