'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var jws = require('jws');

var decodeToken = function decodeToken(token) {
  var decoded = jws.decode(token);
  if (!decoded) {
    return null;
  }
  var payload = decoded.payload;

  //try parse the payload
  if (typeof payload === 'string') {
    try {
      var obj = JSON.parse(payload);
      if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        payload = obj;
      }
    } catch (e) {}
  }

  return {
    header: decoded.header,
    payload: payload,
    signature: decoded.signature
  };
};

module.exports = decodeToken;